#uselib "libzbar-0.dll"
#cfunc global zbar_image_scanner_create "zbar_image_scanner_create"
#func global zbar_image_scanner_set_config "zbar_image_scanner_set_config" sptr,sptr,sptr,sptr
#cfunc global zbar_image_create "zbar_image_create"
#func global zbar_image_set_format "zbar_image_set_format" sptr,sptr
#func global zbar_image_set_size "zbar_image_set_size" sptr,sptr,sptr
#func global zbar_image_set_data "zbar_image_set_data" sptr,sptr,sptr,sptr
#cfunc global zbar_scan_image "zbar_scan_image" sptr,sptr
#cfunc global zbar_image_first_symbol "zbar_image_first_symbol" sptr
#cfunc global zbar_symbol_get_data_length "zbar_symbol_get_data_length" sptr
#cfunc global zbar_symbol_next "zbar_symbol_next" sptr
#cfunc global zbar_symbol_get_type "zbar_symbol_get_type" sptr
#cfunc global zbar_symbol_get_data "zbar_symbol_get_data" sptr
#cfunc global zbar_get_symbol_name "zbar_get_symbol_name" sptr
#func global zbar_image_destroy "zbar_image_destroy" sptr
#func global zbar_image_scanner_destroy "zbar_image_scanner_destroy" sptr
#func global zbar_image_free_data "zbar_image_free_data"
#define global ZBAR_CFG_ENABLE 0
#define global ZBAR_NONE 0/**< no symbol decoded */
#define global ZBAR_PARTIAL 1/**< intermediate status */
#define global ZBAR_EAN8 8/**< EAN-8 */
#define global ZBAR_UPCE 9/**< UPC-E */
#define global ZBAR_ISBN10 10/**< ISBN-10 (from EAN-13). @since 0.4 */
#define global ZBAR_UPCA 12/**< UPC-A */
#define global ZBAR_EAN13 13/**< EAN-13 */
#define global ZBAR_ISBN13 14/**< ISBN-13 (from EAN-13). @since 0.4 */
#define global ZBAR_I25 25/**< Interleaved 2 of 5. @since 0.4 */
#define global ZBAR_CODE39 39/**< Code 39. @since 0.4 */
#define global ZBAR_PDF417 57/**< PDF417. @since 0.6 */
#define global ZBAR_QRCODE 64/**< QR Code. @since 0.10 */
#define global ZBAR_CODE128 128/**< Code 128 */
#define global ZBAR_SYMBOL 0x00ff/**< mask for base symbol type */
#define global ZBAR_ADDON2 0x0200/**< 2-digit add-on flag */
#define global ZBAR_ADDON5 0x0500/**< 5-digit add-on flag */
#define global ZBAR_ADDON 0x0700

#include "color2gray.as"

#module _zbarmod_
#deffunc GetBarCodeStart var buf, int _x, int _y 
	x = _x : y = _y : n = 0 : symbol = 0
	sdim out, x*y
	color2gray varptr(out), varptr(buf), x, y, 2
	scanner = zbar_image_scanner_create()
	zbar_image_scanner_set_config scanner, 0, ZBAR_CFG_ENABLE, 1
	
	image = zbar_image_create()
	zbar_image_set_format image, 0x30303859
	zbar_image_set_size image, x, y
	zbar_image_set_data image, varptr(out), x * y, 0
	n = zbar_scan_image(scanner, image)
	if n < 0 : return -1	// G[
	if n = 0 : return 0		// Ȃ

	symbol.0 = zbar_image_first_symbol(image) 
	repeat n-1, 1
		symbol.cnt = zbar_symbol_next(symbol)
	loop
return n
#deffunc GetBarCodeData int _idx, var _buf
	if length(symbol) <= _idx | _idx < 0 : return -1
	_symbol = symbol(_idx)
	iTyp = zbar_symbol_get_type(_symbol)
	pData = zbar_symbol_get_data(_symbol)
	size = zbar_symbol_get_data_length(_symbol)
	if size <= 0 : return -2
	dupptr sData, pData, size, 2
	sdim _buf, size
	memcpy _buf, sData, size, 0, 0 
return iTyp
#deffunc GetBarCodeType int _type
	pTyp = zbar_get_symbol_name(_type)
	dupptr sTyp, pTyp, 1, 2
	Typ = sTyp
return Typ
#deffunc BarCodeDestroy
	zbar_image_destroy image
	zbar_image_scanner_destroy scanner
	sdim out, 64
return
#global

